/*
**
**
**						Windows UDP Client
**
** This is the windows' client UDP , to send spoofed/unspoofed commands.
**
** ex:
** >winudp.exe source-ip destination-ip dest-port message
**
**
** AUTHOR: Angelo Rosiello
**
**
*/




#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <winsock2.h>
#include <string.h>
#include <assert.h>
#include <fcntl.h>


#define mia_porta 0													// Setting my port to 0 as default
 
int InitializeWinsock(WORD );										// Windows sockets Initializing
void udp_initialize();												// Initializing addresses..

int main(int argc, char *argv[])									// Main of the program
{
	int PORT, binding;
	SOCKET sd;
	struct sockaddr_in server_addr, mio_addr;						// Sockets structure declaration
	if(argc != 5)
	{
		fprintf(stdout, "Windows' UDP client by Angelo Rosiello\n");
		fprintf(stdout, "USAGE: %s SOURCE-IP DEST-IP PORT MESSAGE\n", argv[0]);
		exit(0);
	}

	if (!InitializeWinsock (MAKEWORD(1,1) ) ) return 1;

	PORT = atoi(argv[3]);											// I wish that port! :>

	udp_initialize(&mio_addr, mia_porta, (long) inet_addr(argv[1]));
	udp_initialize(&server_addr, PORT, (long) inet_addr(argv[2]));
	sd = socket(AF_INET, SOCK_DGRAM, 0);							// Setting up UDP
	binding = bind(sd, (struct sockaddr *) &mio_addr, sizeof(mio_addr));
	if(binding != 0) perror("Bind");
	assert(binding == 0);
	sendto(sd, argv[3], strlen(argv[3]), 0, (struct sockaddr *) &server_addr, sizeof(server_addr));
}


/**********************************************
* Initializing addresses Procedure            *
**********************************************/

void udp_initialize(struct sockaddr_in *address, int port, long IPaddr) // Let's initialize UDP address
{
	address->sin_family = AF_INET;
	address->sin_port = htons((u_short)port);
	address->sin_addr.s_addr = IPaddr;
}

/**********************************************
* Windows Sockets Initialization              *
**********************************************/

int InitializeWinsock(WORD wVersionRequested)
{
	WSADATA wsaData;
	int err;

	err = WSAStartup(wVersionRequested, &wsaData);

	if (err!=0) return 0;											// Tell the user that we couldn't find a usable winsock.dll 

	if (LOBYTE(wsaData.wVersion )!=1 || HIBYTE(wsaData.wVersion)!=1) return 0;
	return 1;
}
