/*
***			     Crypto Program
***
***                Copyright (c) 2003 Angelo Rosiello
***                       All Rights Reserved
***                AUTHOR: Angelo Rosiello (Guilecool)
***
*/


#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <assert.h>
#include <unistd.h>
#include <sys/types.h>

char crypto(char ch);

main(int argc, char *argv[])
{
	char ch, crypted;
	int fd, new_fd, lettura;
	if(argc != 3)
	{
		printf("Copyright (c) 2002/03 Angelo Rosiello (Guilecool)\n");
		printf("All Rights Reserved\n");
		printf("USAGE: %s SOURCE-FILE DEST-FILE\n");
		exit(0);
	}
	fd = open(argv[1], O_RDONLY);
	assert(fd > 0);
	if(fd <= 0) perror("file");
        new_fd = open(argv[2], O_CREAT | O_RDWR | O_TRUNC, 0644);
        assert(new_fd > 0);
        if(new_fd <= 0) perror("file");
	while(1)
	{
		lettura = read(fd, &ch, 1);
		if(lettura == 0) break;
		crypted = crypto(ch);
		write(new_fd, &crypted, 1);
	}
		
}

char crypto(char ch)
{
	char crypted;
	int key = 0xff17261;
	crypted = ch ^ key;
	return(crypted);
}
