/*
**
**
**				Unix Udp Client
**
**	This is the Unix client UDP , to send spoofed/unspoofed commands.
**
** ex:
** $./udp source-ip destination-ip dest-port message
**
**
** AUTHOR: Angelo Rosiello (Guilecool)
**
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <assert.h>

#define mia_porta 0
 
void udp_initialize();

int main(int argc, char *argv[]) 
{
	int sd, PORT, binding;
	struct sockaddr_in server_addr, mio_addr;
	if(argc != 5)
	{
		fprintf(stdout, "Unix UDP client by Angelo Rosiello (Guilecool)\n");
		fprintf(stdout, "USAGE: %s SOURCE-IP DEST-IP PORT MESSAGE\n", argv[0]);
		exit(0);
	}

	PORT = atoi(argv[3]);

	udp_initialize(&mio_addr, mia_porta, (long) inet_addr(argv[1]));
	udp_initialize(&server_addr, PORT, (long) inet_addr(argv[2]));
	sd = socket(AF_INET, SOCK_DGRAM, 0);
	binding = bind(sd, (struct sockaddr *) &mio_addr, sizeof(mio_addr));
	if(binding != 0) perror("Bind");
	assert(binding == 0);

	sendto(sd, argv[4], strlen(argv[4]), 0, (struct sockaddr *) &server_addr, sizeof(server_addr));
}

void udp_initialize(struct sockaddr_in *address, int port, long IPaddr) /* Let's initialize UDP, fuck u Pelagatti Lame */
{
	address->sin_family = AF_INET;
	address->sin_port = htons((u_short)port);
	address->sin_addr.s_addr = IPaddr;
}

